MAXLEN = 128

dgraphs = {}
dtrgrs = {}
dpaused = false

function createDGraph(id, opts)
	local g = dgraphs[id]
	if g == nil or not g.x then
		while id > 1 and id > #dgraphs do
			dgraphs[#graphs+1] = {}
		end
		g = opts
		g.id = id
		g.values = {}
		g.f1 = {}
		--g.f2 = {}
		--g.f3 = {}
		g.lastRun = 0
		g.sum = 0
    g.lnSize = 1
		g.range = {}

		g.h = g.h - 2 -- bottom offset
		g.w = g.w - 1 -- right offset
		dgraphs[id] = g
		return
	end

	-- Y-line
	lcd.drawLine(g.x + 1, g.y, g.x + 1, g.y + g.h + 1, SOLID, FORCE or 0)
	lcd.drawPoint(g.x, g.y)
	if g.crit ~= nil then
		lcd.drawPoint(g.x, math.floor(g.y + (g.max - g.crit) * ((g.h-1) / (g.max - g.min))))
	end

	-- X-line
	lcd.drawLine(g.x, g.y + g.h, g.x + g.w, g.y + g.h, SOLID, FORCE or 0)

	if paused then
		lcd.drawText(g.x + (g.w / 2) - 20, g.y + (g.h / 2) - 4, "paused", SMLSIZE+BLINK+INVERS)
	end

	if not g.values or #(g.values) < 2 then
		return
	end

	for j, value in pairs(g.values) do
		if not g.values[j+1] then break end
    
    local fi1 = g.f1[j]
    --local fi2 = g.f2[j]
    --local fi3 = g.f3[j]
    
    
		local nxtVal = g.values[j+1]

		if value < g.min then value = g.min end
		if value > g.max then value = g.max end
		if nxtVal < g.min then nxtVal = g.min end
		if nxtVal > g.max then nxtVal = g.max end

		local range = g.max - g.min
		local maxY = g.y
		local minY = g.h + g.y - (g.lnSize or 1)
    local aa= g.h ;
		local curY = math.floor(maxY + (g.max - value) * ((minY-maxY) / range))
    
    local curYF1 = 0
    --local curYF2 = 0
    --local curYF3 = 0
    if fi1 then
		 curYF1 = math.floor(maxY + (g.max - fi1) * ((minY-maxY) / range))
    end
    --if fi2 then
		-- curYF2 = math.floor(maxY + (g.max - fi2) * ((minY-maxY) / range))
    --end
    --if fi3 then
		-- curYF3 = math.floor(maxY + (g.max - fi3) * ((minY-maxY) / range))
    --end
    
    
    
		local nxtY = math.floor(maxY + (g.max - nxtVal) * ((minY-maxY) / range))
		local lineForm = g.style or (((nxtY >= minY and curY >= minY) or (nxtY <= maxY and curY <= maxY)) and DOTTED or SOLID)

		if g.crit ~= nil then
			lineForm = (value <= g.crit and nxtVal <= g.crit) and DOTTED or SOLID
		end

		for i=0, g.lnSize and g.lnSize-1 or 0 do
			--lcd.drawLine(g.x + (j*g.dp) - g.dp + 2, curY + i, g.x + ((j+1)*g.dp) - g.dp + 2, nxtY + i, lineForm, FORCE or 0)
      
      local yf = minY -(curY + i) + g.y
      local yt = minY -(nxtY + i) + g.y
      
      if g.typ == 0 then
			 lcd.drawLine(g.x + (j*g.dp) - g.dp + 2, yf, g.x + ((j+1)*g.dp) - g.dp + 2,  yt, lineForm, FORCE or 0)
       
      end
      
      if g.typ == 1 then
			 lcd.drawLine(g.x + (j*g.dp) - g.dp + 2, yf, g.x + ((j+1)*g.dp) - g.dp + 2,  yt, lineForm, FORCE or 0)
  		 lcd.drawLine(g.x + (j*g.dp) - g.dp + 2, minY , g.x + ((j+1)*g.dp) - g.dp + 2,  yt, lineForm, FORCE or 0)
      end
    
      if g.typ == 2 then
         if g.dp==1 then
  		     lcd.drawLine(g.x + ((j+1)*g.dp) - g.dp + 2, minY , g.x + ((j+1)*g.dp) - g.dp + 2,  yt, lineForm, FORCE or 0)
         end  
         if g.dp==2 then
  		     lcd.drawLine(g.x + ((j+1)*g.dp) - g.dp + 2, minY , g.x + ((j+1)*g.dp) - g.dp + 2,  yt, lineForm, FORCE or 0)
  		     lcd.drawLine(g.x + ((j+1)*g.dp) - g.dp + 1, minY , g.x + ((j+1)*g.dp) - g.dp + 1,  yt, lineForm, FORCE or 0)
         end  
         
      end
      
      if g.typ == 3 then
       lcd.drawPoint(g.x + (j*g.dp) - g.dp + 2, yf)
      end
      
       if fi1 and fi1>0 and fi1<value then
         --local yf1 = minY -(curYF1 + i) + g.y
         --lcd.drawPoint(g.x + (j*g.dp) - g.dp + 2, yf1)
         local yf1 = minY -(curYF1 + i) + g.y
         local xf1 = g.x + (j*g.dp) - g.dp + 2
         lcd.drawFilledRectangle(xf1, yf1, 4, 2)
         
         
       end
      
      -- if fi2 and fi2>0 and fi2<value then
      --   local yf2 = minY -(curYF2 + i) + g.y
      --   local xf2 = g.x + (j*g.dp) - g.dp + 2
      --   lcd.drawFilledRectangle(xf2, yf2, 2, 2)
      -- end
      
      -- if fi3 and fi3>0 and fi3<value then
      --   local yf3 = minY -(curYF3 + i) + g.y
      --   local xf3 = g.x + (j*g.dp) - g.dp + 2
      --   lcd.drawFilledRectangle(xf3, yf3, 3, 3)
      -- end
      
      
		end
	end
end

function getDGraphRange(id)
	if dgraphs[id] and dgraphs[id].range then
		return { min=dgraphs[id].range.min , max=dgraphs[id].range.max}
	end
	return { min=0, max=0 }
end



function getDGraphAverage(id)
	if dgraphs[id] and dgraphs[id].values then
		local g = dgraphs[id]
		return g.sum ~= 0 and g.sum / #(g.values) or 0
	end
	return 0
end

function setDGraphSpeed(id, spd)
	if dgraphs[id] and dgraphs[id].values then
		local g = dgraphs[id]
    g.speed = spd
	end
end


function initD(id)
	dtrgrs = assert(loadScript("/SCRIPTS/GRAPHS/trigger.lua"))()
	for j, t in pairs(dtrgrs) do
		dtrgrs[j].state = t.func()
	end

	if id and dgraphs[id] then
		dgraphs[id] = {}
		return
	end

	dgraphs = {}
end

function updateD()
	-- triggers
	for j, t in pairs(dtrgrs) do
		local trg = t.func()
		if trg ~= t.state then
			dtrgrs[j].state = trg
		end
	end
	dpaused = dtrgrs.pause.state

	if dpaused then return end

	for i=1,#(dgraphs) do
		local g = dgraphs[i]
		if g.values then
			if g.lastRun == 0 or g.lastRun + g.speed < getTime() then
				local maxValues = math.ceil(g.w / g.dp)
				local vals = g.values
				local vf1 = g.f1
				--local vf2 = g.f2
				--local vf3 = g.f3
        local mmx=0;
        local miix=0;
        
        --[[
				if #vals >= maxValues then
					local tmp = {}
					local tmp1 = {}
					--local tmp2 = {}
					--local tmp3 = {}
					for j=1,#(vals) do
						if j > 1 then
							tmp[j-1] = vals[j]
							tmp1[j-1] = vf1[j]
							--tmp2[j-1] = vf2[j]
							--tmp3[j-1] = vf3[j]
						end
					end 
					g.sum = g.sum - vals[1]
					vals = tmp
					vf1 = tmp1
					--vf2 = tmp2
					--vf3 = tmp3
				end
        ]]--
     
				if #vals >= maxValues then
					for j=2,#(vals) do
							vals[j-1] = vals[j]
							vf1[j-1] = vf1[j]
					end 
					g.sum = g.sum - vals[1]
				end
      
        


        local v
        local f1;
        --local f2;
        --local f3;
        
				if type(g.src) == "function" then
					v = assert(g.src)().deep
          f1= assert(g.src)().f1
          --f2= assert(g.src)().f2
          --f3= assert(g.src)().f3
				else
					v = getValue(g.src)
				end

				if not g.range.min or g.range.min > v then
					g.range.min = v
				end
				if not g.range.max or g.range.max < v then
					g.range.max = v
				end
        
				for j=1,#(vals) do
              if mmx < vals[j] then mmx = vals[j] end
              if miix > vals[j] then miix = vals[j] end
        end        
        
        
        if mmx < 200 then mmx = 200 end
        g.max = mmx
				g.range.max = mmx
				g.range.min = 0

				g.sum = g.sum + v
				
        --vals[#vals+1] = v
				--vf1[#vf1+1] = f1
        
      if (#vals<maxValues)  then
        vals[#vals+1] = v
				vf1[#vf1+1] = f1
      else
        vals[maxValues] = v
				vf1[maxValues] = f1
      end

        

        
				--vf2[#vf2+1] = f2
				--vf3[#vf3+1] = f3
				g.values = vals
				g.f1 = vf1
				--g.f2 = vf2
				--g.f3 = vf3
				g.lastRun = getTime()
				dgraphs[i] = g
			end
		end
	end
end

--return { run=update, init=init }
